fl

{
DogPulseMonitor
 
     PropForth 5.0
     
     RTC DS1337 driver 
     24/03/2012 22:17:10

     RTC DS1337   Propeller
     scl    ----  P28   0x1c
     sda    ----  P29   0x1d
}

hex

\ bcd> ( n1 -- n2 ) convert bcd byte n1 to hex byte n2
[ifndef bcd>
: bcd>
	dup F and
	swap F0 and
	1 rshift dup
	2 rshift + +
;
]

\
\ >bcd ( n1 -- n2 ) convert hex byte n1 to bcd byte n2
[ifndef >bcd
: >bcd
	A u/mod 4 lshift +
;
]

\ _rtcflip7 ( n7 n6 n5 n4 n3 n2 n1 -- n1 n2 n3 n4 n5 n6 n7 ) flip the top 7 items on the stack
: _rtcflip7 
	rot >r rot >r rot >r rot >r rot >r
	swap
	r> r> r> r> r>
	rot >r rot >r rot >r
	swap
	r> r> r>
	swap rot
;

\
\ _DS1337_w ( c1 -- )
: _DS1337_w
	_eewrite
	if
		8007 ERR
	then
;

\ _DS1337_s ( n1 -- )   I2C Start for DS1337  
\                         n1:register address  c1:wr[0]/rd[1]  
: _DS1337_s
	_eestart
	D0 _DS1337_w         \ slave address + wr[0]
	_DS1337_w            \ register adress 
;

\ ( -- )  only Data Read
: _DS1337_sr 
	_eestart  
	D1 _DS1337_w        \ slave address + rd[1] 
;

wvariable rtc_busy

\  ( -- n1 n2 n3 n4 n5 n6 n7 ) read 7 bytes from DS1337
\ n1 - second		(00 - 59)
\ n2 - minute		(00 - 59)
\ n3 - hour		(00 - 23)
\ n4 - day of week 	(1 - 7)
\ n5 - day		(01 - 31)
\ n6 - month		(01 - 12)
\ n7 - yesr		(00 - 99)   
: _DS1337_time_r 0 _DS1337_s _DS1337_sr 6 0 do 0 _eeread loop -1 _eeread _eestop ;

\ ( n1 n2 n3 n4 n5 n6 n7 -- ) write 7 bytes to DS1337 
: _DS1337_time_w _rtcflip7 0 _DS1337_s 7 0 do _DS1337_w loop 0 _eeread drop _eestop ;

\ Read Hr/Min from Ds1337 ( -- n1 n2 )  n1:Minute  n2:Hour
: read_hrmin
_DS1337_time_r
3drop drop
bcd> swap bcd> rot drop swap
;

\ Read&convert all time-data from DS1337
\ ( -- n1 n2 n3 n4 n5 n6 n7 )
\ n1 - second		(00 - 59)
\ n2 - minute		(00 - 59)
\ n3 - hour		(00 - 23)
\ n4 - day of week 	(1 - 7)
\ n5 - day		(01 - 31)
\ n6 - month		(01 - 12)
\ n7 - yesr		(2000 - 2099)   
: read_time 
_DS1337_time_r                
bcd> 7D0 + >r         \ Year
bcd> >r               \ Month  
bcd> >r                \ Day 
 >r                    \ week 
bcd> >r                \ Hour 
bcd> >r                \ Minute 
bcd>                \ Second
r> r> r> r> r> r>

;


\ ( n1 n2 n3 n4 n5 -- ) write Input-datas to DS1337 
\ n1 - yesr		(00 - 99)   
\ n2 - month		(01 - 12)
\ n3 - day		(01 - 31)
\ n4 - hour		(00 - 23)
\ n5 - minute		(00 - 59)
: set_time 
0 rtc_busy W! 
>bcd >r             \ minute
>bcd >r             \ hour
>bcd >r             \ day
>bcd >r             \ month
7D0 - >bcd          \ year
r> r> 0 r> r> 0 _rtcflip7
_DS1337_time_w
read_time . . . . . . .
1 rtc_busy W! 
;

decimal
